/*
 * Info.cpp
 *
 *  Created on: Nov 25, 2009
 *      Author: heber
 */

#include "info.hpp"
#include "log.hpp"
#include "verbose.hpp"

int Info::verbosity = 0;

/**
 * Constructor. Do not use this function. Use getInstance() instead.
 *
 * \return Info instance
 */
Info::Info(const char *msg)
{
  verbosity++;
  FunctionName = msg;
  DoLog(0) && (Log() << Verbose(0) << "Begin of " << FunctionName << endl);
};

/**
 * Destructor. Better use purgeInstance().
 */
Info::~Info() {
  DoLog(0) && (Log() << Verbose(0) << "End of " << FunctionName << endl);
  verbosity--;
}

/**
 * Sets the verbosity.
 *
 * \param verbosityLevel verbosity
 */
void Info::setVerbosity(int verbosityLevel) {
  verbosity = verbosityLevel;
}
